//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C1786A00193.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C1786A00193.cm

//## begin module%3C1786A00193.cp preserve=no
//## end module%3C1786A00193.cp

//## Module: ChiSquare%3C1786A00193; Package body
//## Subsystem: XSFit::StatMethod::ChiSquare%3C17865101B4
//## Source file: /local/data/xerxes1/gordon/oldplot/headas/Xspec/src/XSFit/StatMethod/ChiSquare/ChiSquare.cxx

//## begin module%3C1786A00193.additionalIncludes preserve=no
//## end module%3C1786A00193.additionalIncludes

//## begin module%3C1786A00193.includes preserve=yes
//## end module%3C1786A00193.includes

// Fit
#include <XSFit/Fit/Fit.h>
// Background
#include <XSModel/Data/BackCorr/Background.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// Weight
#include <XSModel/GlobalContainer/Weight.h>
// Model
#include <XSModel/Model/Model.h>
// ChiSquare
#include <XSFit/StatMethod/ChiSquare/ChiSquare.h>


//## begin module%3C1786A00193.declarations preserve=no
//## end module%3C1786A00193.declarations

//## begin module%3C1786A00193.additionalDeclarations preserve=yes
#include <XSFit/Fit/FitMethod.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/GlobalContainer/DataSetTypes.h>
#include <XSModel/Parameter/ModParam.h>
#include <XSModel/Data/Detector/Response.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Utils/XSutility.h>
#include <XSUtil/Numerics/Gamma.h>
#include <XSUtil/Error/Error.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <XSsymbol.h>
#include <iostream>
#include <iomanip>
#include <typeinfo>
#include <set>
#include <numeric>
#include <sstream>
#include <cmath>
using namespace XSContainer;
//## end module%3C1786A00193.additionalDeclarations


// Class ChiSquare 

ChiSquare::ChiSquare()
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_const.hasinit preserve=yes
  : StatMethod("chi"), 
    m_specsWithZeroVarChans(),
    m_difference(),
    m_variance(),
    m_fullName("Chi-Squared"),
    m_scriptName("\\gx\\u2\\d"),
    m_dSigma()
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_const.hasinit
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_const.initialization preserve=yes
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_const.initialization
{
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_const.body preserve=yes
   isDerivAnalytic(true);
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_const.body
}

ChiSquare::ChiSquare(const ChiSquare &right)
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_copy.hasinit preserve=yes
  : StatMethod(right), 
    m_specsWithZeroVarChans(right.m_specsWithZeroVarChans),
    m_difference(right.m_difference), 
    m_variance(right.m_variance),
    m_fullName(right.m_fullName),
    m_scriptName(right.m_scriptName),
    m_dSigma(right.m_dSigma)
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_copy.hasinit
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_copy.initialization preserve=yes
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_copy.initialization
{
  //## begin ChiSquare::ChiSquare%3B7BFB6F0280_copy.body preserve=yes
  //## end ChiSquare::ChiSquare%3B7BFB6F0280_copy.body
}



//## Other Operations (implementation)
void ChiSquare::doPerform (Fit* fit)
{
  //## begin ChiSquare::doPerform%3B7BFE0D0311.body preserve=yes
        
  // alright, now we perform the sum of the statistic over the models.
  Real chiSquare(0.);
  
  std::set<string>::iterator ss (fit->activeModels().begin());
  std::set<string>::iterator ssEnd (fit->activeModels().end());
  while ( ss != ssEnd)
  {
     models->calculate(*ss);
     models->fold(*ss);
     ++ss;
  }   
  
  doReset(fit);
  
  // Check and fix zero-variance bins PRIOR to adding any model
  // systematic variance. But if "model" weighting is in use,
  // we can only check AFTER weighting is applied.
  m_specsWithZeroVarChans.clear();
  SpectralDataMapConstIt   sm (fit->spectraToFit().begin());
  SpectralDataMapConstIt   smEnd (fit->spectraToFit().end());
  if (weight()->name() != string("model"))
  {
     while (sm != smEnd)
     {
        RealArray& var  = m_variance[sm->first];
        if (applyMinVariance(sm->second, var))
        {
           m_specsWithZeroVarChans.push_back(sm->first);
        }
        ++sm;
     }
  }
    
  ModelMapConstIter ml (models->modelSet().begin());      
  ModelMapConstIter  mlEnd (models->modelSet().end());      
  while ( ml != mlEnd )
  {
     // D - F for each model. In the case where there are multiple
     // sources difference will be iteratively defined.
     Model* m (ml->second);
     if (m->isActive())
     {
        m->difference(m_difference);                  
        weight()->dataVariance(*m,m_variance);
     }
     ++ml;
  }
  
  // Now do check for case of model weighting.
  if (weight()->name() == string("model"))
  {
     sm = fit->spectraToFit().begin();
     while (sm != smEnd)
     {
        const RealArray& var = m_variance[sm->first];
        const size_t varSz = var.size();
        for (size_t i=0; i<varSz; ++i)
        {
           if (var[i] == 0.0)
           {
              std::ostringstream oss;
              oss << "Cannot calculate chi-square using model weighting on spectrum "<< sm->first 
                   <<"\nModel weighting causes it to contain 1 or more channels with zero variance.\n\n";
              statistic(-1.0);
              throw YellowAlert(oss.str());
           } 
        }
        ++sm;
     }
  }    
  
  // Now calculate chi-square    
  int savConVerbose = tpout.conVerbose();
  int savLogVerbose = tpout.logVerbose();
  XSstream::verbose(tpout,35,35); 
  sm = fit->spectraToFit().begin();        
  while ( sm != smEnd )
  {
     size_t index = sm->first;
     const RealArray& diff = m_difference[index];
     RealArray& var  = m_variance[index];
     RealArray quot  (diff*diff/var);
     if ( tpout.maxChatter() >= 35 )
     {
        tcout << "ChiSquare::doPerform output" <<std::endl;
        tcout << " i data  diff  var \n" ;
        size_t N (diff.size());
	std::vector<Real> PS(N);
	std::partial_sum(&quot[0],&quot[0]+N,PS.begin());

        for (size_t i = 0; i < N; ++i)
        {
           tcout << i << "  " << sm->second->spectrum()[i] 
                 << " " << diff[i]
                 << " " << var[i] << " "  << quot[i]
                 << " " << PS[i]  << '\n';
        }
        tcout << std::endl;

     }
     chiSquare += quot.sum();             
     ++sm;       
  } 
  XSstream::verbose(tpout, savConVerbose, savLogVerbose);
  // output section, to be encapsulated.
  
  Real bayesianPrior = bayes().lPrior(fit);           
  statistic(chiSquare - 2.0*bayesianPrior);

  //## end ChiSquare::doPerform%3B7BFE0D0311.body
}

void ChiSquare::setWeight (const std::string& weightName)
{
  //## begin ChiSquare::setWeight%3C4EF5FC01BC.body preserve=yes
  // weightName string should already have been validated as
  // corresponding to an actual weight.
  Weight* input (weightScheme(weightName));
  if ( input )
  {
        weight(input);
        
        tcout << " Chi-Squared statistic: variance weighted using " << input->name() 
                        << " weighting" << std::endl;
  }
  else
  {
     throw RedAlert("Invalid weight scheme in ChiSquare::setWeight");
  } 
  //## end ChiSquare::setWeight%3C4EF5FC01BC.body
}

void ChiSquare::doInitialize (Fit* fit)
{
  //## begin ChiSquare::doInitialize%3C598E1C0041.body preserve=yes
        
    // Important: initialize has two definitions, one where allocations 
    // take place (called for each fit) and one per iteration where
    // arrays for variance, difference are reset to their values for
    // a new iteration.
    // SO NEED to ADD new function reset() to do the 
        
    // deal with the common operations: initialize arrays needed for holding
    // derivatives (if required by fit's FitMethod).
        
    StatMethod::doInitialize(fit);   
    
    // now, initialize arrays that are specific to ChiSquare.
    // each is an array of arrays of size # of noticed channels,
    // one per spectrum loaded. 
     
    // for every weighting technique except model weighting, the variance
    // is constant (independent of the model) apart from a possible systematic
    // term we can add later. If the weighting is Model, then the data variance
    // is given by the sum of the model weight and the background variance. 
    // so here we need to store the background variance in the variance array.
    // If model systematic errors or model errors are called for these will be
    // added during iteration by the Weight::dataVariance() function.
    ArrayContainer::const_iterator pw (protoWorkspace().begin());
    ArrayContainer::const_iterator pwEnd  (protoWorkspace().end());
    

    
    
    while ( pw != pwEnd )
    {
          m_variance.insert(ArrayContainer::value_type(pw->first,pw->second));
          m_difference.insert(ArrayContainer::value_type(pw->first,pw->second));
          ++pw;
    }

    doReset(fit);
  //## end ChiSquare::doInitialize%3C598E1C0041.body
}

void ChiSquare::doDeallocate ()
{
  //## begin ChiSquare::doDeallocate%3C5AAD6900ED.body preserve=yes
  StatMethod::doDeallocate();      
        
  m_variance.clear();
  m_difference.clear();
  m_dSigma.clear();
  //## end ChiSquare::doDeallocate%3C5AAD6900ED.body
}

void ChiSquare::doReset (Fit* fit)
{
  //## begin ChiSquare::doReset%3C6BE44E007C.body preserve=yes
        
  // StatMethod::doReset(fit);        

  // reset quantities specific to ChiSquare object for new iteration.
  
  SpectralDataMapConstIt   sm (fit->spectraToFit().begin());
  SpectralDataMapConstIt   smEnd (fit->spectraToFit().end());
  while ( sm != smEnd )
  {
        size_t index = sm->first;
        SpectralData* spectrum = sm->second;
        const std::valarray<size_t>& IN = spectrum->indirectNotice();
        // Subtle note: Because we are retrieving a subset from
        // a non-const valarray, if we don't do the static cast
        // it will remain as type indirect_array<Real>.  For some
        // reason on Solaris, this then causes a memory leak when 
        // assigned to m_difference[index].  The cast seems to get
        // rid of this.  
        m_difference[index] = RealArray(spectrum->spectrum()[IN]);
        if (weight()->name() == string("model"))
           m_variance[index] = RealArray(.0, IN.size());
        else
           m_variance[index] = RealArray(spectrum->variance()[IN]);
        if (spectrum->background())
        {
           m_difference[index] -= 
                           spectrum->background()->spectrum()[IN];
           if (spectrum->background()->variance().size() > 0)
           {
                   m_variance[index] += 
                           spectrum->background()->variance()[IN];
           }

        }
        if (spectrum->correction() && spectrum->correctionScale() != 0) 
        {
                m_difference[index] -=  spectrum->correctionScale()
                        *spectrum->correction()->spectrum()[IN];         
        }     
        ++sm;
  }
  
  ArrayContainer::iterator dsig = m_dSigma.begin();
  ArrayContainer::iterator dsigEnd = m_dSigma.end();
  while (dsig != dsigEnd)
  {
     dsig->second = 0.;
     ++dsig;
  }      
  //## end ChiSquare::doReset%3C6BE44E007C.body
}

ChiSquare* ChiSquare::clone () const
{
  //## begin ChiSquare::clone%3C84ECAC01E0.body preserve=yes
  return new ChiSquare(*this);
  //## end ChiSquare::clone%3C84ECAC01E0.body
}

void ChiSquare::doReport (Fit* fit) const
{
  //## begin ChiSquare::doReport%3C90CF3F01F9.body preserve=yes
  using namespace std;
  int degrees (0);
  size_t bins(0);
  degreesOfFreedom(fit,degrees,bins);
  ios_base::fmtflags save(tcout.flags());
  streamsize savePrec(tcout.precision());
  if (!fit->spectraToFit().empty())
  {
     Numerics::GammaQ GQ;
     Real nullHyp = GQ( degrees/2. , statistic()/2.);
     Real truncatedStat = setOutputFormat(fit);
     tcout << "\n Chi-Squared = " << setw(14) << truncatedStat << " using " << bins << " PHA bins.";
     if (nullHyp == -99)
     {
        // Something went wrong in GammaQ.
        tcout << "\n Cannot calculate null hypothesis probability."<<endl;
     }
     else
     {
        truncatedStat = setOutputFormat(fit, degrees);
        tcout << "\n Reduced chi-squared = " << setw(14) << truncatedStat << " for " 
              << setw(6) << degrees << " degrees of freedom " << setprecision(6) 
              << "\n Null hypothesis probability = " << setw(14) << scientific << nullHyp << endl;  
     }
  }
  else
  {
     tcout.setf(ios_base::fixed);
     tcout << "\n Chi-Squared = " << setw(14) << "0.0" << " using " << 0 << " PHA bins." << endl;     
  }
  tcout.precision(savePrec);
  tcout.flags(save);
  
  if (m_specsWithZeroVarChans.size())
  {
     tcout <<"\n***Warning: Chi-square may not be valid due to bins with zero variance"
           <<"\n            in spectrum number(s): ";
     for (size_t i=0; i<m_specsWithZeroVarChans.size(); ++i)
        tcout << m_specsWithZeroVarChans[i] <<" ";
     tcout << "\n" << std::endl;
  }
  //## end ChiSquare::doReport%3C90CF3F01F9.body
}

Real ChiSquare::plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const
{
  //## begin ChiSquare::plotChi%3DD26F740268.body preserve=yes
  Real point (obs - mod > 0 ? (obs - mod)*(obs - mod) : -(obs - mod)*(obs - mod) );
  Real msyst (models->modelSystematicError());
  Real var   (msyst > 0 ? error*error + msyst*msyst*mod*mod : error*error);
  point /= var;
        
  return point;       
  //## end ChiSquare::plotChi%3DD26F740268.body
}

Real ChiSquare::plotDeltaChi (Real obs, Real mod, Real error, const Real& NODATA) const
{
  //## begin ChiSquare::plotDeltaChi%3DD26F79017E.body preserve=yes
  Real point ( obs - mod );
  Real msyst (models->modelSystematicError());
  Real var ( msyst > 0 ?  sqrt(error*error + msyst*msyst*mod*mod) : error ); 
  point /= var;
  return point;
  //## end ChiSquare::plotDeltaChi%3DD26F79017E.body
}

ArrayContainer ChiSquare::getDifferences (const Fit* fit) const
{
  //## begin ChiSquare::getDifferences%3FAFBDAD0340.body preserve=yes
  // seems a waste perhaps to return just a copy of previously calculated array,
  // but not all statistics will have calculated this.
  // the object of providing this virtual function is to support
  // peak residual calculation - may be there are other uses also.
  return m_difference;
  //## end ChiSquare::getDifferences%3FAFBDAD0340.body
}

Real ChiSquare::sumSecondDerivs (int pi, int pj, bool isPiResp, bool isPjResp)
{
  //## begin ChiSquare::sumSecondDerivs%416D580103BD.body preserve=yes
  Real alpha_ij=.0;
  ArrayContainer::const_iterator varEnd = m_variance.end();
  ArrayContainer::const_iterator sigmaEnd = m_dSigma.end();
  if (!isPiResp && !isPjResp)
  {
     // Calculate (2/var)*(dF/dpi)(dF/dpj) summed over all fit spectra.
     const ArrayContainer& piBins = dModel().find(pi)->second;
     const ArrayContainer& pjBins = dModel().find(pj)->second;
     ArrayContainer::const_iterator piSpec = piBins.begin();
     ArrayContainer::const_iterator piEnd = piBins.end();
     ArrayContainer::const_iterator pjEnd = pjBins.end();
     while (piSpec != piEnd)
     {
        // ASSUMES piBins and pjBins containers have same number of
        // RealArrays, which are indexed by the same spectra numbers.
        // Does NOT ASSUME that iterating through both in parallel will
        // grab RealArrays corresponding to the same spectrum.
        size_t specNum = piSpec->first;
        ArrayContainer::const_iterator pjSpec = pjBins.find(specNum);
        ArrayContainer::const_iterator var = m_variance.find(specNum);
        if (pjSpec == pjEnd || var == varEnd)
        {
           throw RedAlert("Chi-Square calc: Second derivatives array container size mismatch.");
        }
        RealArray secondDeriv(piSpec->second);
        secondDeriv *= pjSpec->second;
        secondDeriv /= var->second;
        ArrayContainer::const_iterator sigmaSpec = m_dSigma.find(specNum);
        if (sigmaSpec != sigmaEnd)
        {
           RealArray sigmaCorrection;
           calcD2Sigma(specNum, sigmaCorrection);
           secondDeriv *= sigmaCorrection;
        } 
        alpha_ij += secondDeriv.sum();
        ++piSpec;
     }
     alpha_ij *= 2.0;
  }
  else
  {
     // 1 or both pars are response pars.   In all 3 possible
     // cases, only 1 spectrum (at most) applies.
     size_t onlySpec = 0;
     std::map<size_t,ArrayContainer>::const_iterator piContainer = 
                dModel().find(pi);
     std::map<size_t,ArrayContainer>::const_iterator pjContainer = 
                dModel().find(pj);
     if (isPiResp)
     {
        piContainer = dRM().find(pi);
        if (piContainer == dRM().end())
        {
           throw RedAlert("Chi-Square 2nd deriv: missing response parameter");
        }
        onlySpec = piContainer->second.begin()->first;
     }
     if (isPjResp)
     {
        pjContainer = dRM().find(pj);
        if (pjContainer == dRM().end())
        {
           throw RedAlert("Chi-Square 2nd deriv: missing response parameter");
        }
        size_t tmp = pjContainer->second.begin()->first;
        if (onlySpec && (tmp != onlySpec))
        {
           // 2 response pars belonging to different spectra.
           // No terms contribute to 2nd derivative.
           return 0.0;
        }
        onlySpec = tmp;
     }
     const RealArray& piSpec = piContainer->second.find(onlySpec)->second;
     const RealArray& pjSpec = pjContainer->second.find(onlySpec)->second;
     ArrayContainer::const_iterator var = m_variance.find(onlySpec);
     if (var == varEnd)
     {
        throw RedAlert("Chi-Square calc: Second derivatives array container size mismatch.");
     }
     RealArray secondDeriv(piSpec);
     secondDeriv *= pjSpec;
     secondDeriv /= var->second;
     ArrayContainer::const_iterator sigmaSpec = m_dSigma.find(onlySpec);
     if (sigmaSpec != sigmaEnd)
     {
        RealArray sigmaCorrection;
        calcD2Sigma(onlySpec, sigmaCorrection);
        secondDeriv *= sigmaCorrection;
     }
     alpha_ij = 2.0*secondDeriv.sum(); 
  }
  return alpha_ij;
  //## end ChiSquare::sumSecondDerivs%416D580103BD.body
}

Real ChiSquare::sumDerivs (int parameterIndex, bool isRespar)
{
  //## begin ChiSquare::sumDerivs%416D58B802AB.body preserve=yes
    // The m_difference array will contain the quantity
    // d = (D-F), the m_variance array will contain the variance var, 
    // corrected for any model systematic terms. Calculation of m_difference
    // is done in Model::difference(ArrayContainer&) which is invoked by
    // ChiSquare::doPerform
               
    // the derivative of X^2 wrt each parameter j for each folded model F is then 
    // -2 Sigma_i ( d_i/var_i +  d_i/var_i [dsigma_i/dF] dF_i/dpj )
    // the second term is the 'weight derivative' and is provided by the
    // Weight::varianceDeriv function for each array in the model.
        
    // ChiSquare can work with the sum of the derivative components from
    // each of multiple sources.
    ArrayContainer& dm = dModel()[parameterIndex];
    
    Real dSdpj (0.);
    int savConVerbose = tpout.conVerbose();
    int savLogVerbose = tpout.logVerbose();
    if (!isRespar)
    {
       ArrayContainer::const_iterator d (dm.begin());
       ArrayContainer::const_iterator dEnd (dm.end());
       XSstream::verbose(tpout,33,33);         
       while (d != dEnd)
       {
	   size_t n = d->first;
	   RealArray dSdpA (m_difference[n]);
           dSdpA *= d->second;

	   dSdpA /= m_variance[n];
           ArrayContainer::const_iterator itSig = m_dSigma.find(n);
	   if ( itSig != m_dSigma.end() )
	   {
               const RealArray& dSig_n = itSig->second;
	       dSdpA *= (1. + m_difference[n]/m_variance[n]
		         *dSig_n);
	   }
	   dSdpj += -2.0*dSdpA.sum();
           if ( tpout.maxChatter() >= 33 )
	   {
	       size_t N = m_difference[n].size();
	       std::vector<Real> PS(N);
	       std::partial_sum(&dSdpA[0],&dSdpA[0]+N,PS.begin());
	       tcout << " Spectrum " << d->first << " Parameter# " << parameterIndex  
                               << " D:  " << dSdpj << '\n';
	       for (size_t j = 0; j < N; ++ j)
	       {
		   tcout << j << " " << std::setw(12) << m_difference[n][j]  << " "
		         << std::setw(12) << m_variance[n][j] << " "
		         << std::setw(12) << (d->second)[j]  << " "
		         << std::setw(12) << dSdpA[j] << " "
		         << std::setw(12) << PS[j]  << '\n'; 
	       }
	       tcout << " d " << n << "  " << dSdpj << '\n';  
	   }          
	   ++d;
       } // end spectra loop.
    } // end if not a Response parameter.
    else
    {
       std::map<size_t,ArrayContainer>::const_iterator dFdPContainer = dRM().find(parameterIndex);
       // For response parameters, dFdPContainer should only have
       // 1 entry, since only 1 spectrum is associated with reponse.
       int specNum = dFdPContainer->second.begin()->first;
       const RealArray& dFdP = dFdPContainer->second.begin()->second;
       RealArray dSdpA(m_difference[specNum]);
       dSdpA /= m_variance[specNum];
       dSdpA *= dFdP;
       ArrayContainer::const_iterator itSig = m_dSigma.find(specNum);
       if ( itSig != m_dSigma.end() )
       {
           const RealArray& dSig_n = itSig->second;
	   dSdpA *= (1. + m_difference[specNum]/m_variance[specNum]
		     *dSig_n);
       }
       dSdpj = -2.0*dSdpA.sum();
    }
    XSstream::verbose(tpout, savConVerbose, savLogVerbose);

    return dSdpj;

  //## end ChiSquare::sumDerivs%416D58B802AB.body
}

void ChiSquare::calcD2Sigma (size_t specNum, RealArray& correction) const
{
  //## begin ChiSquare::calcD2Sigma%416D96420021.body preserve=yes
  // If variance has a model dependency, calculate contribution
  // to second derivatives.  This assumes dSigma has already
  // been determined to have array corresponding to specNum.
  // Let g = ((D-F)*sigma*d(sigma)/dF)/sigma^2,  then correction
  // = (1 + 4g + 3g^2).
    RealArray g(m_dSigma.find(specNum)->second);
    g *= m_difference.find(specNum)->second;
    g /= m_variance.find(specNum)->second;
    correction.resize(g.size());
    correction = g;
    correction *= g;
    correction *= 3.0;
    correction += 4.0*g;
    correction += 1.0;
  //## end ChiSquare::calcD2Sigma%416D96420021.body
}

void ChiSquare::getWeightDerivs (Fit* fit)
{
  //## begin ChiSquare::getWeightDerivs%416EB17902EB.body preserve=yes
    // the loop around models computes a dF_i array for each parameter that
    // the model depends on. We must also produce a varianceDeriv ArrayContainer
    // object that returns -0.5*sigma_i*dsigma_i/dF (the extra factor of sigma is
    // there so we can compute just d_i and var_i). 
    ModelMapConstIter mm (models->modelSet().begin());
    ModelMapConstIter mmEnd (models->modelSet().end());
    while ( mm != mmEnd )
    {
        Model& m (*mm->second);
        if ( m.isActive()) weight()->varianceDeriv(m,m_dSigma);
	++mm;       
    }

  //## end ChiSquare::getWeightDerivs%416EB17902EB.body
}

std::pair<Real,Real> ChiSquare::adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen)
{
  //## begin ChiSquare::adjustForFrozen%448456FA016F.body preserve=yes
    // NOTE:  This ASSUMES m_difference and m_variance have been reset to their
    // initial values in doReset, prior to their usage here.  It is perhaps less
    // dangerous to simply call doReset from here, but that would result in many
    // redundant calls (see how adjustForFrozen is called from StatMethod::renormalize).
   const std::valarray<size_t>& IN = spec->indirectNotice();
   const size_t N = IN.size(); 
   size_t specNum = spec->spectrumNumber();
   std::pair<Real,Real> fSums(0.,0.);
   const RealArray& pha = m_difference[specNum];
   RealArray totalModel(0.,N);
   RealArray totModFroz(.0,N);
   RealArray var(m_variance[specNum]);
   applyMinVariance(spec, var);
   for (size_t i=0; i<models.size(); ++i)
   {
      Model* mod = models[i];
      std::map<Model*,ArrayContainer >::const_iterator itSaved =
                savedValsForFrozen.find(mod);
      if (itSaved != savedValsForFrozen.end())
      {
         totalModel += itSaved->second.find(specNum)->second[IN];
         totModFroz += mod->foldedModel(specNum)[IN];
      }
      else
      {
         totalModel += mod->foldedModel(specNum)[IN];
      }
   }
   RealArray totModNonFroz(totalModel - totModFroz);
   RealArray obsNonFroz((pha - totModFroz)*totModNonFroz);
   fSums.first = (obsNonFroz/var).sum();
   fSums.second = (totModNonFroz*totModNonFroz/var).sum();
   
   //print frozen and total arrays to log file for debugging purposes.
   int savConVerbose = tpout.conVerbose();
   int savLogVerbose = tpout.logVerbose();
   XSstream::verbose(tpout,33,33);         
   if ( tpout.maxChatter() >= 33 )
   {
      using std::setw;
      tcout.precision(6);
      for ( size_t j = 0; j < N ; ++j)
      {
         tcout   <<  " i " << setw(5) << j 
                 << " obs " << setw(12) << pha[j]
                 << " mod " << setw(12) << totalModel[j] ;
            tcout << " fro " << setw(12) << totModFroz[j];
         tcout << '\n';
      }
      tcout << " ofSum " << fSums.first << " mfSum " << fSums.second 
                << std::endl;
    }        
   XSstream::verbose(tpout, savConVerbose, savLogVerbose);
   
   return fSums;
  //## end ChiSquare::adjustForFrozen%448456FA016F.body
}

bool ChiSquare::applyMinVariance (const SpectralData* sd, RealArray& variance)
{
  //## begin ChiSquare::applyMinVariance%44999EA1013F.body preserve=yes
     bool isRequired = false;
     const std::valarray<size_t>& IN = sd->indirectNotice();
     RealArray areaTime = sd->exposureTime()*sd->areaScale()[IN];
     const size_t sz = variance.size();
     RealArray backAreaTime(-1.0, areaTime.size());
     RealArray bscaleRatio(1.0, areaTime.size());
     if (sd->background())
     {
        const SpectralData* bckSpec = sd->background()->data();
        backAreaTime = bckSpec->exposureTime()*bckSpec->areaScale()[IN];
        bscaleRatio = sd->backgroundScale()[IN]/bckSpec->backgroundScale()[IN];
     }
     for (size_t i=0; i<sz; ++i)
     {
        if (variance[i] == 0.0)
        {
           variance[i] = ChiSquare::calcMinVariance(areaTime[i], backAreaTime[i],
                                bscaleRatio[i]);
           isRequired = true;
        }
     }
     return isRequired;
  //## end ChiSquare::applyMinVariance%44999EA1013F.body
}

Real ChiSquare::calcMinVariance (Real areaTime, Real backAreaTime, Real bscaleRatio)
{
  //## begin ChiSquare::calcMinVariance%44A97E1F022D.body preserve=yes
   Real minVar = .0;
   // Use negative backAreaTime as a flag indicating no background file.
   if (backAreaTime < .0)
   {
      minVar = 1.0/(areaTime*areaTime);
   }
   else
   {
      Real factor = 1.0/(areaTime*areaTime);
      Real backFactor = (bscaleRatio*bscaleRatio)/(backAreaTime*backAreaTime);
      minVar = std::min(factor, backFactor);
   }
   return minVar;
  //## end ChiSquare::calcMinVariance%44A97E1F022D.body
}

// Additional Declarations
  //## begin ChiSquare%3B7BFB6F0280.declarations preserve=yes
  //## end ChiSquare%3B7BFB6F0280.declarations

//## begin module%3C1786A00193.epilog preserve=yes
//## end module%3C1786A00193.epilog
